var polling = true;

var xmlhttp = false;
var u = "error";

function set_user(user) {
  u = user
}

function createXmlHttp ()
{
  try {
    xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
  } catch (e) {
    try {
      xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
    } catch (e) {
      xmlhttp = false;
    }
  }
  if (!xmlhttp && typeof XMLHttpRequest != 'undefined') {
    xmlhttp = new XMLHttpRequest();
  }

  return xmlhttp;
}

function submit(xmlhttp, req) {
  xmlhttp.open("GET", req, true);
  xmlhttp.onreadystatechange=function() {
    if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
      res = xmlhttp.responseText;
      document.getElementById("hall").innerHTML = res;
    }
  }
  xmlhttp.send(null);
  reconnect();
}

function reconnect() {
  if (working) return;
  if (resumeTimer) {
    clearTimeout(resumeTimer);
    resumeTimer = false;
  }
  reload();
}

function submit_talk() {
/*  if (document.talkForm.msg.value == "") return; */
  xmlhttp = createXmlHttp();
  msg = encodeURIComponent(document.talkForm.msg.value);
  document.talkForm.msg.value = "";
  submit(xmlhttp, "write.cgi?u="+u+"&msg="+msg);
}

function submit_topic() {
  if (document.topicForm.topic.value == "") return;
  xmlhttp = createXmlHttp();
  msg = encodeURIComponent(document.topicForm.topic.value);
  document.topicForm.topic.value = "";
  submit(xmlhttp, "write.cgi?u="+u+"&topic="+msg);
}

var working = false;

function awake() {
  working = true;
  document.getElementById("user").style.color = "#282";
  document.getElementsByName("talkSubmit")[0].value = "ȯ";
}

function sleep() {
  working = false;
  document.getElementById("user").style.color = "#000";
  document.getElementsByName("talkSubmit")[0].value = "³";
}

var resumeTimer = false;

function resume() {
  if (working) return;
  var xmlhttp = createXmlHttp();
  xmlhttp.open("GET", "write.cgi?u="+u+"&msg=", false);
  xmlhttp.send(null);
  var res = xmlhttp.responseText;
  var hall = document.getElementById("hall");
  if (hall.innerHTML != res) {
    hall.innerHTML = res;
    reload();
  }
  else {
    resumeTimer = setTimeout("resume()", 240000);
  }
}

function reload() {
  if (working) return;
  awake();
  var xmlhttp = createXmlHttp();
  xmlhttp.open("GET", "serv.cgi?"+u, true);
  xmlhttp.onreadystatechange=function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        res = xmlhttp.responseText;
        if (res.substring(0, 2) != "no") {
          document.getElementById("hall").innerHTML = res;
        }
        else if (polling) {
          sleep();
          resumeTimer = setTimeout("resume()", 240000);
          return;
        }
      }
      working = false;
      reload();
    }
  }
  xmlhttp.send(null);
}

function handle(ev) {
  // ESCAPE
  if (ev.keyCode == 27) {
    document.talkForm.msg.value = "";
  }

  reconnect();
}
