#!/usr/bin/env ruby

require 'nkf'
require 'pstore'

require 'catalog'
require 'util'
require 'plugin'

print "Content-Type: text/html; charset=EUC-JP\r\n\r\n"
print HEAD

cgi = query()
udb = get_udb()

begin
  u = safe(cgi['u'])
  u_ = safe(cgi['u_'])
  if cgi['mode'] == 'log'
    print %Q(</head><body>
<h1>#{TITLE} - </h1>
<div class="log"><ul class="logList">
)
    if File.exist?('chat.txt')
      File.open('chat.txt', 'r') do |i|
        i.flock(File::LOCK_SH)
        print i.read
        i.flock(File::LOCK_UN)
      end
    end
    print '</ul></div>'
  elsif !u
    print %Q(</head><body>)
    print LOGIN
    udb.transaction(true) do
      puts get_users(udb)
      puts get_topic(udb)
    end
  else
    raise 'Υ桼̾ѤǤޤ' if u == ''
    raise '__ǻϤޤ桼̾ѤǤޤ' if u =~ /^__/

    udb.transaction do
      login(udb, u)
      sweep_timeout(udb)
      require 'mkdat'
      mkdat_udb(udb, u)
    end

    print %Q(
<script type="text/javascript" charset="EUC-JP" src="kocha.js">
</script>
</head>
<body onLoad="set_user('#{u_}'); reload();">
#{c(BODY, get_hall(), u, u_)}
)
  end
rescue
  print "<h1>ʤ󤫥顼</h1>"
  print "<p>#{$!}</p>"
  print %Q(<pre>#{$!.backtrace.join("\n")}</pre>)
  print "<p>֥饦뤢äƤ</p>"
end

print FOOT
